/*
 * 	Cdigo de Marc Torramilans Peidro
 *  Projecte Escola d'Enginyeria de Terrasa
 *  
 *  
 */

package com.project.guitarlearner;


import android.app.Activity;
import android.media.AudioFormat;
import android.media.AudioRecord;
import android.media.MediaRecorder.AudioSource;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;
import android.widget.Toast;
public class Codi extends Activity implements OnClickListener {
	private static final int LOG2_FFTSIZE = 12;
	private static final int FFT_SIZE = 1 << LOG2_FFTSIZE;
	double frequencia_corda;
	private TextView texto;
	public static int MILISEGUNDOS = 3000;
	public static int afinacio = -1;
	int RATE = 8000;
	int mida_buffer_MS = 4000; 
	int mida_buffer_bytes = 2 * RATE * mida_buffer_MS/ 1000 ;
	int mida_chunk_MS = 500;
	int mida_chunk_short = RATE * mida_chunk_MS/ 1000;// 4000
	short[] audio_data = new short[mida_buffer_bytes/2]; 
			AudioRecord recorder = new AudioRecord(AudioSource.MIC, RATE, 
					AudioFormat.CHANNEL_CONFIGURATION_MONO,
					AudioFormat.ENCODING_PCM_16BIT, mida_buffer_bytes);
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.afinar2);
		texto = (TextView) findViewById(R.id.afinar);
		//Set up click listeners for all the buttons


		View recordButton = findViewById(R.id.record_button);
		recordButton.setOnClickListener(this);



	}
	//Funci que retorna el mxim d'una trama
	public double max(double[] x, int ini, int fin){
		double max = 0.0;
		for (int i=ini; i < fin; i++)
		{
			if (Math.abs (x[i]) >= max)
			{
				max = Math.abs (x[i]);
			}
		}


		return max;
	}
	//Funci que retorna la afinaci
	public int afinador4 (short[] x, double fr){


		int ms1 = RATE/400;
		int ms20 = RATE/80;
		int longtrama = 500;
		int L = FFT_SIZE;
		int N = x.length;
		int Nt = N/L;
		int m1,m2;
		double fz = 0, fx = 0, fr_a_mirar = 0;
		double[] trama = new double[L];
		double[] realArray = new double[L];
		double[] imagArray = new double[L];
		double[] C = new double[L];
		double[] Fo = new double[Nt];
		FFT fft = new FFT(LOG2_FFTSIZE);

		for (int t = 0; t < Nt; t++)
		{
			m1 = (t)*L + 1;
			m2 = (m1+L) -1;
			if (m2<N)
			{
				for (int i=0, m=m1; i<L; m++, i++)
				{
					trama[i]=x[m];
				}
			}
			if (max(trama,0,L) > 0.1)
			{
				if (trama.length < FFT_SIZE)
				{
					realArray[1] = -1.0;
				}
				//Posar les dades de la trama en els vectors.
				//Les dades no tenen part imaginria.
				for(int i=0; i < FFT_SIZE; i++) 
				{
					realArray[i] = trama[i];
					imagArray[i] = 0.0;
				}
				//Fer la fft.
				fft.doFFT(realArray, imagArray, false);
				for(int i=0; i < FFT_SIZE; i++)
				{
					C[i] = Math.abs (Math.log (trama[i]));
				}
				fft.doFFT(C, imagArray, false);
				fx = max (C,ms1,ms20);
				fz = RATE/(ms1+fx-1);
			}
			else
			{
				fz = 0.0;
			}
			Fo[t] = fz;
		}


		fr_a_mirar = max(Fo,0,Nt);

		if (fr_a_mirar>=fr-fr*0.3 && fr_a_mirar<=fr+fr*0.3) 
			{
			afinacio = 0;
			}
		else if (fr_a_mirar<=fr-fr*0.3)
		{
			afinacio = -1;
		}
		else
		{
			afinacio = 1;
		}

		return afinacio;

	}
	//Comprova quin bot s'ha pitjat

	//
	public void onClick(View v) {
		switch (v.getId()) {
		

		case R.id.record_button:

			if (recorder.getState() != AudioRecord.STATE_INITIALIZED) {
				ShowError("Can't initialize AudioRecord");
				return;
			}
			frequencia_corda=440;
			recorder.startRecording();
			recorder.read(audio_data, 0, mida_buffer_bytes/2); 
			recorder.stop();
			recorder.release();
			afinador4 (audio_data,frequencia_corda);
//			Intent i = new Intent(this, EstatCorda.class);
//			startActivity(i);
			esperarYCerrar(3000);
			texto.setText("Calculando..");
			Toast.makeText(this, "Analizando..", Toast.LENGTH_SHORT);
			 if (Codi.afinacio == 0) //corda ben afinada
			 {
				 Toast.makeText(this, "Bien afinada", Toast.LENGTH_SHORT);
				 texto.setText("Bien afinada");
				   
			 }
			 if (Codi.afinacio == -1) //corda destensada
			 {
				 Toast.makeText(this, "Cuerda destensada", Toast.LENGTH_SHORT);
				 texto.setText("Cuerda destensada");
			 }
			 if (Codi.afinacio == 1) //corda massa tensada
			 {
				 Toast.makeText(this, "Cuerda tensada", Toast.LENGTH_SHORT);
				 texto.setText("Cuerda tensada");
			 }


//			finish();
			break;

		}//switch
	}//onclick
	public void esperarYCerrar(int milisegundos) {
        Handler handler = new Handler();
        handler.postDelayed(new Runnable() {
            public void run() {
                // acciones que se ejecutan tras los milisegundos
               
            }
        }, milisegundos);
    }
	private void ShowError(String string) {
		//TODO Auto-generated method stub
	}
}
