package com.project.guitarlearner;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class MainActivity extends Activity {
	private Button bMayores;
	private Button bMenores;
	private Button bPartes;
	private Button bAfinar;
	private Button bHistoria;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		bMayores = (Button) findViewById(R.id.may);
		bMenores = (Button) findViewById(R.id.men);
		bPartes = (Button) findViewById(R.id.partes);
		bAfinar = (Button) findViewById(R.id.afinar);
		bHistoria = (Button) findViewById(R.id.historia);

		bMayores.setOnClickListener(new OnClickListener() {
          public void onClick(View view) {
            		lanzarbMayores(null);
           }
		});
		
		bMenores.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				
				lanzarbMenores(null);
			}
		});
		bPartes.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				lanzarPartes(null);
				//lanzar (null);
			}
		});
		bAfinar.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				lanzarAfinador(null);
				//lanzar (null);
			}
		});
		
		bHistoria.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				
				lanzarHistoria(null);
			}
		});
		
		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	public void lanzarbMayores(View view){
		  Intent i = new Intent(this, AcordesMayores.class);

	      startActivity(i);
	}
	public void lanzarbMenores(View view){
		  Intent i = new Intent(this, AcordesMenores.class);

	      startActivity(i);
	
	}
	
	public void lanzarPartes(View view){
		  Intent i = new Intent(this, Partes.class);

	      startActivity(i);
	}
	public void lanzarHistoria(View view){
		  Intent i = new Intent(this, Historia.class);

	      startActivity(i);
	}
	
	public void lanzarAfinador(View view){
		  Intent i = new Intent(this, Afinar.class);

	      startActivity(i);
			
	}

}
